;if aliases is called with isid it returns the dll results
;for example /MircDB opendb dbname is not return any value
;//echo $MircDB(opendb,dbname) returns the database name or error
alias MircDB {
  if !$com(MircDB) { 
    .comopen MircDB MircDB.Main
    if ($comerr) {
      .comreg $qt($+($scriptdir,MircDB.dll))
      .comopen MircDB MircDB.Main
      if ($comerr) halt
    }
  }
  if $1 == Close { .comclose MircDB }
  else {
    var %k = $com(MircDB,$1,3,bstr,$2-)
    if $isid { return $com(MircDB).result }
  }
}


alias example_1 {

  ;is database exist??
  if $exists(example.mdb) { MircDB Close | .remove example.mdb  }

  ;creat example.mdb on mirc directory also it is opened the example.mdb
  echo $MircDB(CreateDB,example.mdb)

  ;check example table is exist?
  if Error: 3265 isin $MircDB(Tables,table(ExampleTable)) {

    ;if returns 1 ExampleTable Created successfully
    echo $iif($MircDB(SQL,CREATE TABLE ExampleTable) == 1,ExampleTable Created,$v1)
  }
  ;check any field exist on a ExampleTable Error: 3066 returns if not exist error mesage if used it
  ;Error: 3066 Description: Query must have at least one destination field.

  if Error: 3066 isin $MircDB(SQL,SELECT * FROM ExampleTable) {
    ;if returns 1 ExampleField with integer property is Created..
    echo $iif($MircDB(sql,ALTER TABLE ExampleTable ADD ExampleField Integer) == 1,ExampleField [Integer] Created,$v1)
  }
  else { 
    ;if ExamapleField is not exist lets create it
    if Error: 3265 isin $MircDB(Records,field(ExampleField).name) {
      echo $iif($MircDB(sql,ALTER TABLE ExampleTable ADD ExampleField Integer) == 1,ExampleField [Integer] Created,$v1)
    }
  }

  ;lets fill same data inside the ExampleField :D
  var %i = 1
  while %i <= 250 {
    MircDB sql Insert INTO ExampleTable (ExampleField) VALUES (' $+ %i $+ ')
    inc %i 1
  }
  MircDb Close
  echo ExampleField filled 250 integer numbers :). try /example_2
}


alias example_2 {
  echo $MircDB(OpenDB,example.mdb)

  ;if ExamapleField is exist
  MircDB SQL SELECT * FROM ExampleTable
  if Error: 3265 isin $MircDB(Records,field(ExampleField).name) { echo ExampleField is not exist to create it please use /example_1 | halt }
  ;lets select max 10 records
  var %Number_of_Records =  $MircDB(SQL,SELECT TOP 10  ExampleField FROM ExampleTable ORDER BY ExampleField DESC)
  if Error isin %Number_of_Records { echo %Number_of_Records }
  else {
    echo MAX 10 Records:
    var %i = 1
    while %i <= %Number_of_Records {
      echo $+(%i,:) $MircDB(Records,field(0))
      ;lets move next record next or movenext same :D
      MircDB Records next
      inc %i 1
    }
  }

  ;lets select less 10 records
  var %Number_of_Records =  $MircDB(SQL,SELECT TOP 10  ExampleField FROM ExampleTable ORDER BY ExampleField ASC)
  if Error isin %Number_of_Records { echo %Number_of_Records }
  else {
    echo LESS 10 Records:
    var %i = 1
    while %i <= %Number_of_Records {
      echo $+(%i,:) $MircDB(Records,field(0))
      ;lets move next record next or movenext same :D
      MircDB Records next
      inc %i 1
    }
  }

  ;lets select average of records
  var %Number_of_Records = $MircDB(SQL,SELECT AVG(ExampleField) FROM ExampleTable)
  if Error isin %Number_of_Records { echo %Number_of_Records }
  else { echo Average of records: $MircDB(Records,field(0)) }
  MircDB Close
  echo Example 2 finished try: /example_3
}



alias example_3 {
  if Error: 3024 !isin $MircDB(OpenDB,example.mdb) {
    echo $v2
  }
  else { echo example.mdb is not exist please use example_1 to create it :) | halt }

  ;check if any table exist 
  if Error: 3066 !isin $MircDB(SQL,SELECT * FROM ExampleTable) { 

    ;if is ExampleField exist?
    if Error: 3265 !isin $MircDB(Records,field(ExampleField).name) {
      ;lets remove ExampleField
      echo : $MircDB(SQL,ALTER TABLE ExampleTable DROP ExampleField)
    }
  }
  ;mirc allowed almost 900 byte data to set variable etc
  ;so Lets use MdbStr function %')

  ;clearing mdb str if stted before 
  echo : $MircDB(MdbStr,Clear)

  ;lets add 899 x and 1 space char to a MdbStr on a dll with using $str
  echo $iif($MircDB(MdbStr,ADD $str(x,899) $+ $chr(32)) == 1,x 899 times Added,$v1)

  ;add 899 y and 1 space
  echo $iif($MircDB(MdbStr,ADD $str(y,899) $+ $chr(32)) == 1,y 899 times Added,$v1)

  ;add 899 z and 1 space
  echo $iif($MircDB(MdbStr,ADD $str(z,899) $+ $chr(32)) == 1,z 899 times Added,$v1) 

  ;finaly add them on a database but we have an a field firstly lets create it
  ;creating Memo field, it's allowed to store huge amount of data

  ;if is ExampleField exist? SQL query setted before so we do not need it again.
  ;if not exist Error will be returned so we wont this for create a field.
  if Error isin $MircDB(Records,field(ExampleMemoField).name) {
    echo $iif($MircDB(sql,ALTER TABLE ExampleTable ADD ExampleMemoField Memo) == 1,ExampleField [Integer] Created,$v1)
  }
  ;fill memo field with MdbStr with starting by my nick Alience :D
  echo $iif($MircDB(sql,INSERT INTO ExampleTable (ExampleMemoField) VALUES ('Alience MdbStr')) == 1,Total Data added,$v1)

  ;Hmm Mirc allowed 900 character w added 3 times of that how can we read it :)
  ;Lets use Records field().getpart start length (like mirc $mid fonction :D)
  ;first we must select records
  echo $iif(Error !isin $MircDB(sql,SELECT * FROM ExampleTable WHERE ExampleMemoField = 'Alience MdbStr'),Added Data Selected,$v1)

  ;display length of the record
  echo Length of record: $MircDB(Records,field(ExampleMemoField).len)

  ;get my nick :D
  echo $MircDB(Records,field(ExampleMemoField).getpart 1 7)

  ;get 899 x
  echo $MircDB(Records,field(ExampleMemoField).getpart 8 899)

  MircDB Close
}
